// This class can be modified and is for testing your solution.
// Modifications will NOT be reviewed or assessed.
//
public class PraxisTest1 {

    public static void main(String[] args) {

        Point p1 = new Point(1,2);
        Point p2 = new Point(4,8);
        Point p3 = new Point(3,-4);
        Point p4 = new Point(-1,2);
        Point p5 = new Point(-4,7);
        Point p6 = new Point(2, 3);
        Point p7 = new Point(1, 1);

        System.out.println("Test 'add' method:");
        SortedSinglyLinkedList l1 = new SortedSinglyLinkedList(new Point(1, 0));
        testTrue(l1.add(p1)); // [1,2]
        testTrue(l1.add(p2)); // [4,8]
        testTrue(!l1.add(new Point(1,2))); // already in list!
        testTrue(l1.add(p3)); // [-3,4]
        testTrue(l1.add(p4)); // [-1,2]
        testTrue(l1.add(p5)); // [-4,6]
        testTrue(l1.add(p6)); // [-2,3]
        testTrue(l1.add(p7)); // [1,1]

        System.out.println("Test constructor with 'add' and 'size':");
        SortedSinglyLinkedList l2 = new SortedSinglyLinkedList(l1, new Point(4,7));
        testTrue(!l1.add(p1)); // [1,2] already in list!
        testTrue(!l1.add(p2)); // [4,8] already in list!
        testTrue(!l2.add(p3)); // [-3,4] already in list!
        testTrue(!l2.add(p4)); // [-1,2] already in list!
        testTrue(!l2.add(p5)); // [-4,6] already in list!
        testTrue(!l2.add(p6)); // [-2,3] already in list!
        testTrue(!l2.add(p7)); // [1,1] already in list!
        testValue(l2.size(),7);

        System.out.println("Test 'toString' method:");
        testEquals(new SortedSinglyLinkedList(new Point(1, 0)).toString(), "[] ref [1,0]");
        testEquals(l1.toString(),
                "[[1,1], [1,2], [-1,2], [2,3], [3,-4], [4,8], [-4,7]] ref [1,0] min 1 max 12");

        System.out.println("Test 'size' method:");
        testValue(l1.size(),7);

        System.out.println("Test 'removeOutsideRange' method with 'size':");
        SortedSinglyLinkedList l3 = l1.removeOutsideRange(5);
        testValue(l1.size(),4);
        testValue(l3.size(),3);

        System.out.println("Test 'removeOutsideRange' method with 'toString':");
        testEquals(new SortedSinglyLinkedList(new Point(0, 1))
                .removeOutsideRange(0).toString(), "[] ref [0,1]");
        testEquals(l1.toString(), "[[1,1], [1,2], [-1,2], [2,3]] ref [1,0] min 1 max 4");
        testEquals(l3.toString(), "[[3,-4], [4,8], [-4,7]] ref [1,0] min 6 max 12");

    }

    public static void testEquals(Object given, Object expected) {
        if (given == expected) {
            System.out.println("Successful test");
            return;
        } else {
            if (given == null) {
                System.out.println("Test NOT successful! Expected value: " +
                        expected +
                        " / Given value: null");
                return;
            }
            if (expected == null) {
                System.out.println("Test NOT successful! Expected value: null / " +
                        "Given value: " + given);
                return;
            }
        }
        if (given.equals(expected)) {
            System.out.println("Successful test");
        } else {
            System.out.println("Test NOT successful! Expected value: " + expected.toString() + " / Given " +
                    "value: " + given.toString());
        }
    }

    public static void testTrue(boolean expectedTrue) {
        if (expectedTrue) {
            System.out.println("Successful test");
        } else {
            System.out.println("Test NOT successful! Expression should be 'true' but is 'false'.");
        }
    }

    public static void testEquals(Point given, Point expected) {
        if (given == expected) {
            System.out.println("Successful test");
            return;
        } else {
            if (given == null) {
                System.out.println("Test NOT successful! Expected value: " +
                        "(" + expected.toString() + ")" +
                        " / Given value: null");
                return;
            }
            if (expected == null) {
                System.out.println("Test NOT successful! Expected value: null / " +
                        "Given value: " + "(" + given.toString() + ")");
                return;
            }
        }

        if (given.isEqualTo(expected)) {
            System.out.println("Successful test");
        } else {
            System.out.println("Test NOT successful! Expected value: (" + expected.toString() +
                    ") / " +
                    "Given value: (" + given.toString() + ")");
        }
    }

    public static void testValue(int given, int expected) {
        if (given == expected) {
            System.out.println("Successful test");
        } else {
            System.out.println("Test NOT successful! Expected value: " + expected + " / Given value: " + given);
        }
    }

}
